
// Obrim la BBDD amb la que treballarà la App.
var chimpdb = openDatabase('cbapp', '1.0', 'DB Chimpanzee Bar App', 2 * 1024 * 1024);

//Funció de creació de Taules dintre la BBDD
		
		function initdb(){
			
			chimpdb.transaction(function (tx) {
				// Fem la crida SQL per la cració de taula
				tx.executeSql('CREATE TABLE Languages (Id_Language PRIMARY KEY, Language)');
			});		
			chimpdb.transaction(function (tx) {
				tx.executeSql('CREATE TABLE LanguageItem (Id_Language, Id_Item , LanguageName, Description, PRIMARY KEY(Id_Language, Id_Item))');
			});	
			chimpdb.transaction(function (tx) {
				tx.executeSql('CREATE TABLE Config (Id_Config PRIMARY KEY, CValue)');
			});
			chimpdb.transaction(function (tx) {
				tx.executeSql('CREATE TABLE WebShops (Id_Shop PRIMARY KEY, Website, Email )');
			});		
			chimpdb.transaction(function (tx) {
				tx.executeSql('CREATE TABLE Products (Id_Product PRIMARY KEY, Family, Vegan, GlutenFree, Organic, Kcal, Kj, Weight )');
			});	
			chimpdb.transaction(function (tx) {
				tx.executeSql('CREATE TABLE Ingredients (Id_Ingredient PRIMARY KEY, Organic )');
			});
			chimpdb.transaction(function (tx) {
				tx.executeSql('CREATE TABLE Nutrition (Id_Nutrition PRIMARY KEY, MesureUnit )');
			});
			chimpdb.transaction(function (tx) {
				tx.executeSql('CREATE TABLE ProductIngredient (Id_Product, Id_Ingredient, PRIMARY KEY(Id_Product, Id_Ingredient))');
			});	
			chimpdb.transaction(function (tx) {
				tx.executeSql('CREATE TABLE ProductNutrition (Id_Product, Id_Nutrition, Quantity, PRIMARY KEY(Id_Product, Id_Nutrition))');
			});	
			chimpdb.transaction(function (tx) {
				tx.executeSql('CREATE TABLE Shops (Name, Lng, Lat, PRIMARY KEY(Lng, Lat))');
			});	
		}
		
//Totes les funcions següents son d'inclusió de dades a les taules.

		function insertTableLanguages(id,lang){
			
			chimpdb.transaction(function (tx) {
			//Fem la crida SQL per introduïr les dades passades per paràmetre a la taula corresponent
			tx.executeSql('INSERT INTO Languages (Id_Language, Language) VALUES ("'+ id +'", "'+ lang +'")');
			//console.log(id + lang);
			});	
		}
		
		function insertTableLanguageItem (id,lang, langname,descrip){
			
			chimpdb.transaction(function (tx) {
			tx.executeSql('INSERT INTO LanguageItem (Id_Language, Id_Item, LanguageName, Description) VALUES ("'+ id +'", "'+ lang +'", "'+ langname +'", "'+ descrip +'")');
			//console.log(id + lang, langname, descrip);
			});	
		}
		
		function insertTableConfig (id,value){
			
			chimpdb.transaction(function (tx) {
			tx.executeSql('INSERT INTO Config (Id_Config, CValue) VALUES ("'+ id +'", "'+ value +'")');
			//console.log(id + value);
			});	
		}
		
		function insertTableWebShops (id,value, mail){
			
			chimpdb.transaction(function (tx) {
			tx.executeSql('INSERT INTO WebShops (Id_Shop, Website, Email) VALUES ("'+ id +'", "'+ value +'", "'+ mail +'")');
			//console.log(id + value);
			});	
		}
		
		function insertTableProducts (id,family, vegan, gluten, organic, cal, jul, weight){
			
			chimpdb.transaction(function (tx) {
			tx.executeSql('INSERT INTO Products (Id_Product, Family, Vegan, GlutenFree, Organic, Kcal, Kj, Weight ) VALUES ("'+ id +'", "'+ family +'", "'+ vegan +'", "'+ gluten +'", "'+ organic +'", "'+ cal +'", "'+ jul +'", "'+ weight +'")');
			//console.log(id + value);
			});	
		}
		
		function insertTableIngredients (id,value){
			
			chimpdb.transaction(function (tx) {
			tx.executeSql('INSERT INTO Ingredients (Id_Ingredient, Organic) VALUES ("'+ id +'", "'+ value +'")');
			//console.log(id + value);
			});	
		}
		
		function insertTableNutrition (id,mes){
			
			chimpdb.transaction(function (tx) {
			tx.executeSql('INSERT INTO Nutrition (Id_Nutrition, MesureUnit) VALUES ("'+ id +'", "'+ mes +'")');
			});	
		}
		
		function insertTableProductIngredient (idp,idi){
			
			chimpdb.transaction(function (tx) {
			tx.executeSql('INSERT INTO ProductIngredient (Id_Product, Id_Ingredient ) VALUES ("'+ idp +'", "'+ idi +'")');
			//console.log(id + value);
			});	
		}
		
		function insertTableProductNutrition (idp,idi, qty){
			
			chimpdb.transaction(function (tx) {
			tx.executeSql('INSERT INTO ProductNutrition (Id_Product, Id_Nutrition, Quantity ) VALUES ("'+ idp +'", "'+ idi +'", "'+ qty +'")');
			//console.log(id + value);
			});	
		}
		
		function insertTableShops (name,lng, lat){
			
			chimpdb.transaction(function (tx) {
			tx.executeSql('INSERT INTO Shops (Name, Lng, Lat ) VALUES ("'+ name +'", "'+ lng +'", "'+ lat +'")');
			//console.log(id + value);
			});	
		}
		
		
//Modificar el llenguatge actiu a la app
		function updateLanguage(id){
			//Comprobem que el valor passat per paràmetre no sigui nul
			if (id>0){
			chimpdb.transaction(function (tx) {
			//fem la crida SQL per a actualitzar el idioma actiu a la app
			tx.executeSql('UPDATE Config set CValue="'+id+'" where Id_config="Language";');
			console.log("updated to "+id);
			location.reload();
			//console.log(id + value);
			});	
			}
		}
		
		
//Modificar pas per parametre
		function updateConfigProduct(id){
			
			chimpdb.transaction(function (tx) {
			tx.executeSql('UPDATE Config set CValue="'+id+'" where Id_config="Product";');
			console.log("updated to "+id);
			location.reload();
			//console.log(id + value);
			});	
		}
		
//Funció de lectura de dades XML i crides per a introduïr dades al WebSQL	
		function getXMLLanguages(){
	
			// Objecte de lectura XML
			xmlhttp=new XMLHttpRequest();
		
			// Obrim l'arxiu XML
			xmlhttp.open("GET","xml/Languages.xml",false);
			xmlhttp.send();

			// Obtemin l'objecte XMLDocument amb el contingut XML
			xmlDoc=xmlhttp.responseXML;

			// Obtenim tots els nodes de l'arxiu XML
			var languages=xmlDoc.getElementsByTagName("Languages");

			// Llegim tots els nodes i els passem a la funció que les introducirà a la WebSql
			for(var i=0;i<languages.length;i++)
				{
				// Preparem els valors a passar per paràmetre
				idlanguage=languages[i].getElementsByTagName("Id_Language")[0].textContent; //childNodes[0].nodeValue
				language=languages[i].getElementsByTagName("Language")[0].textContent; //childNodes[0].nodeValue
				// Cridem la funció de cridarà l'SQL
				insertTableLanguages(idlanguage,language);
				}
}



		function getXMLLanguageItem(){
	
			xmlhttp=new XMLHttpRequest();
			xmlhttp.open("GET","xml/LanguageItem.xml",false);
			xmlhttp.send();
			xmlDoc=xmlhttp.responseXML;
			var languageitem =xmlDoc.getElementsByTagName("LanguageItem");

			for(var i=0;i<languageitem.length;i++)
				{
				idlanguage=languageitem[i].getElementsByTagName("Id_Language")[0].textContent; //childNodes[0].nodeValue
				iditem=languageitem[i].getElementsByTagName("Id_Item")[0].textContent; //childNodes[0].nodeValue	
				name=languageitem[i].getElementsByTagName("LanguageName")[0].textContent; //childNodes[0].nodeValue	
				description=languageitem[i].getElementsByTagName("Description")[0].textContent; //childNodes[0].nodeValue
				insertTableLanguageItem(idlanguage,iditem, name, description);
				}
}


		function getXMLConfig(){
	
			xmlhttp=new XMLHttpRequest();
			xmlhttp.open("GET","xml/Config.xml",false);
			xmlhttp.send();
			xmlDoc=xmlhttp.responseXML;
			var conf =xmlDoc.getElementsByTagName("Config");

			for(var i=0;i<conf.length;i++)
			{
				idconfig=conf[i].getElementsByTagName("Id_Config")[0].textContent; //childNodes[0].nodeValue
				configvalue=conf[i].getElementsByTagName("CValue")[0].textContent; //childNodes[0].nodeValue
				insertTableConfig(idconfig, configvalue);
			}
}

		function getXMLWebShop(){
	
			xmlhttp=new XMLHttpRequest();
			xmlhttp.open("GET","xml/WebShop.xml",false);
			xmlhttp.send();
			xmlDoc=xmlhttp.responseXML;
			var data =xmlDoc.getElementsByTagName("WebShop");

			for(var i=0;i<data.length;i++)
			{
				idshop=data[i].getElementsByTagName("Id_Shop")[0].textContent; //childNodes[0].nodeValue
				website=data[i].getElementsByTagName("Website")[0].textContent; //childNodes[0].nodeValue
				email=data[i].getElementsByTagName("E-mail")[0].textContent; //childNodes[0].nodeValue	
				insertTableWebShops(idshop, website, email);
			}
}



		function getXMLProducts(){

			xmlhttp=new XMLHttpRequest();
			xmlhttp.open("GET","xml/Products.xml",false);
			xmlhttp.send();
			xmlDoc=xmlhttp.responseXML;

			var data =xmlDoc.getElementsByTagName("Products");

			for(var i=0;i<data.length;i++)
			{
				idprod=data[i].getElementsByTagName("Id_Product")[0].textContent; 
				family=data[i].getElementsByTagName("Family")[0].textContent; 
				vegan=data[i].getElementsByTagName("Vegan")[0].textContent; 
				gluten=data[i].getElementsByTagName("GlutenFree")[0].textContent; 
				organic=data[i].getElementsByTagName("Organic")[0].textContent; 
				cal=data[i].getElementsByTagName("Kcal")[0].textContent; 
				jul=data[i].getElementsByTagName("KJ")[0].textContent; 
				weight=data[i].getElementsByTagName("Weight")[0].textContent; 
	
				insertTableProducts(idprod, family, vegan, gluten, organic, cal, jul, weight);
			}
	}
	
	

		function getXMLIngredients(){

			xmlhttp=new XMLHttpRequest();
			xmlhttp.open("GET","xml/Ingredients.xml",false);
			xmlhttp.send();
			xmlDoc=xmlhttp.responseXML;
	
			var data =xmlDoc.getElementsByTagName("Ingredients");

			for(var i=0;i<data.length;i++)
			{
				idind=data[i].getElementsByTagName("Id_ingredient")[0].textContent; 
				org=data[i].getElementsByTagName("Organic")[0].textContent; 
	
				insertTableIngredients(idind, org);
			}
	}
	
	function getXMLNutrition(){

		xmlhttp=new XMLHttpRequest();
		xmlhttp.open("GET","xml/Nutrition.xml",false);
		xmlhttp.send();
		xmlDoc=xmlhttp.responseXML;

		var data =xmlDoc.getElementsByTagName("Nutrition");

		for(var i=0;i<data.length;i++)
			{
			id=data[i].getElementsByTagName("Id_Nutrition")[0].textContent; 
			mesure=data[i].getElementsByTagName("MesureUnit")[0].textContent; 
	
			insertTableNutrition(id, mesure);
	
			}
	}
	

	
	function getXMLProductIngredient(){

		xmlhttp=new XMLHttpRequest();
		xmlhttp.open("GET","xml/ProductIngredient.xml",false);
		xmlhttp.send();
		xmlDoc=xmlhttp.responseXML;

		var data =xmlDoc.getElementsByTagName("ProductIngredient");

		for(var i=0;i<data.length;i++)
			{
			idp=data[i].getElementsByTagName("Id_Product")[0].textContent; 
			idi=data[i].getElementsByTagName("Id_Ingredient")[0].textContent; 
	
			insertTableProductIngredient(idp,idi);
	
			}
	}
	
		
	function getXMLProductNutrition(){

		xmlhttp=new XMLHttpRequest();
		xmlhttp.open("GET","xml/ProductNutrition.xml",false);
		xmlhttp.send();
		xmlDoc=xmlhttp.responseXML;

		var data =xmlDoc.getElementsByTagName("ProductNutrition");

		for(var i=0;i<data.length;i++)
			{
			idp=data[i].getElementsByTagName("Id_Product")[0].textContent; 
			idi=data[i].getElementsByTagName("Id_Nutrition")[0].textContent; 
			qty=data[i].getElementsByTagName("Quantity")[0].textContent; 
	
			insertTableProductNutrition(idp,idi,qty);
	
			}
	}

	
	function getXMLShops(){

		xmlhttp=new XMLHttpRequest();
		xmlhttp.open("GET","xml/Shops.xml",false);
		xmlhttp.send();
		xmlDoc=xmlhttp.responseXML;

		var data =xmlDoc.getElementsByTagName("Placemark");

		for(var i=0;i<data.length;i++)
			{
			name=data[i].getElementsByTagName("name")[0].textContent; 
			lng=data[i].getElementsByTagName("lng")[0].textContent; 
			lat=data[i].getElementsByTagName("lat")[0].textContent; 
			insertTableShops (name,lng,lat);
	
			}
	}